| Server IP : 39.106.62.82 / Your IP : 216.73.216.253 Web Server : nginx/1.14.1 System : Linux iz2ze1m0zmp2dk5c3j5ap5z 3.10.0-1127.19.1.el7.x86_64 #1 SMP Tue Aug 25 17:23:54 UTC 2020 x86_64 User : www ( 1000) PHP Version : 7.4.33 Disable Function : passthru,exec,system,putenv,chroot,chgrp,chown,shell_exec,popen,proc_open,pcntl_exec,ini_alter,ini_restore,dl,openlog,syslog,readlink,symlink,popepassthru,pcntl_alarm,pcntl_fork,pcntl_waitpid,pcntl_wait,pcntl_wifexited,pcntl_wifstopped,pcntl_wifsignaled,pcntl_wifcontinued,pcntl_wexitstatus,pcntl_wtermsig,pcntl_wstopsig,pcntl_signal,pcntl_signal_dispatch,pcntl_get_last_error,pcntl_strerror,pcntl_sigprocmask,pcntl_sigwaitinfo,pcntl_sigtimedwait,pcntl_exec,pcntl_getpriority,pcntl_setpriority,imap_open,apache_setenv MySQL : OFF | cURL : ON | WGET : ON | Perl : ON | Python : ON | Sudo : ON | Pkexec : ON Directory : /lib/udev/ |
Upload File : |
PATH='/sbin:/bin'
source /etc/eni_utils/eni-helper
# Read a single line from file $1 in the $DEVPATH directory.
# The function must not return an error even if the file does not exist.
sysread() {
local file="$1"
[ -e "/sys$DEVPATH/$file" ] || return 0
local value
read value < "/sys$DEVPATH/$file" || return 0
echo "$value"
}
sysreadlink() {
local file="$1"
[ -e "/sys$DEVPATH/$file" ] || return 0
readlink -f /sys$DEVPATH/$file 2> /dev/null || true
}
# Return true if a directory is writeable.
writeable() {
if ln -s test-link $1/.is-writeable 2> /dev/null; then
rm -f $1/.is-writeable
return 0
else
return 1
fi
}
#fix me
RUNDIR=/dev/.udev
if [ ! -d $RUNDIR ]; then
mkdir -p $RUNDIR
fi
# Create a lock file for the current rules file.
lock_rules_file() {
eni_log 'rule_generator.functions: enter lock_rules_file'
#fix me
#RUNDIR=$(udevadm info --run)
eni_log "rule_generator.functions: RUNDIR: ${RULES_LOCK}"
[ -e "$RUNDIR" ] || return 0
RULES_LOCK="$RUNDIR/.lock-${RULES_FILE##*/}"
eni_log "rule_generator.functions: run dir: RULES_LOCK: ${RULES_LOCK}"
retry=30
while ! mkdir $RULES_LOCK 2> /dev/null; do
eni_log "rule_generator.functions: enter lock rules file while loop 3333 trying to mkdir $RULES_LOCK"
if [ $retry -eq 0 ]; then
echo "Cannot lock $RULES_FILE!" >&2
exit 2
fi
sleep 1
retry=$(($retry - 1))
done
eni_log 'rule_generator.functions: enter lock rules file 4444'
}
unlock_rules_file() {
eni_log 'rule_generator.functions: enter unlock_rules_file'
[ "$RULES_LOCK" ] || return 0
rmdir $RULES_LOCK || true
}
# Choose the real rules file if it is writeable or a temporary file if not.
# Both files should be checked later when looking for existing rules.
choose_rules_file() {
#fix me
#RUNDIR=$(udevadm info --run)
local tmp_rules_file="$RUNDIR/tmp-rules--${RULES_FILE##*/}"
eni_log "rule_generator.functions: tmp_rules_file is: ${tmp_rules_file}"
eni_log "rule_generator.functions: RULES_FILE is: ${RULES_FILE}"
[ -e "$RULES_FILE" -o -e "$tmp_rules_file" ] || PRINT_HEADER=1
if writeable ${RULES_FILE%/*}; then
RO_RULES_FILE='/dev/null'
else
RO_RULES_FILE=$RULES_FILE
RULES_FILE=$tmp_rules_file
fi
}
# Return the name of the first free device.
raw_find_next_available() {
local links="$1"
local basename=${links%%[ 0-9]*}
local max=-1
for name in $links; do
local num=${name#$basename}
[ "$num" ] || num=0
[ $num -gt $max ] && max=$num
done
local max=$(($max + 1))
# "name0" actually is just "name"
[ $max -eq 0 ] && return
echo "$max"
}
# Find all rules matching a key (with action) and a pattern.
find_all_rules() {
local key="$1"
local linkre="$2"
local match="$3"
local search='.*[[:space:],]'"$key"'"('"$linkre"')".*'
echo $(sed -n -r -e 's/^#.*//' -e "${match}s/${search}/\1/p" \
$RO_RULES_FILE \
$([ -e $RULES_FILE ] && echo $RULES_FILE) \
2>/dev/null)
}